<template>
  <div>
    <div class="d-flex justify-space-between">
      <div style="width: 100px;">
        <v-select
          v-model="perPage"
          :label="$t('totalVisible')"
          :items="listPerPage"
          @change="getMateriales"
          dense
        />
      </div>
      <div class="d-flex justify-end">
        <v-btn
          v-if="!esPedido"
          class="mt-2 mr-4"
          color="success"
          rounded
          small
          @click="nuevoMaterial"
          :disabled="loading"
        >
          <v-icon>mdi-table-plus</v-icon>
          {{ $t('nuevoMaterial') }}
        </v-btn>
        <v-btn
          class="mt-2 mr-4"
          color="primary"
          rounded
          small
          @click="refreshTable"
          :disabled="loading"
        >
          <v-icon>mdi-refresh</v-icon>
          {{ $t('actualizar') }}
        </v-btn>
        <v-pagination
          v-model="currentPage"
          :disabled="loading"
          :length="lastPage"
          :total-visible="8"
        />
      </div>
    </div>
    <v-data-table
      v-model="selected"
      :headers="headers"
      :items="materialData"
      item-key="id"
      class="elevation-1"
      disable-pagination
      hide-default-footer
      dense
      :loading="loading"
    >
      <template v-slot:item.actions="{ item }">
        <v-menu
          v-if="!esPedido"
          bottom
          left
        >
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              icon
              v-bind="attrs"
              v-on="on"
            >
              <v-icon>mdi-dots-vertical</v-icon>
            </v-btn>
          </template>
          <v-list dense>
            <v-list-item-group>
              <v-list-item>
                <v-list-item-icon>
                  <v-icon>mdi-pencil</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title @click="editarMaterial(item)">{{ $t('editar') }}</v-list-item-title>
                </v-list-item-content>
              </v-list-item>
              <v-list-item>
                <v-list-item-icon>
                  <v-icon>mdi-printer</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title @click="kardex(item)">{{ $t('kardex') }}</v-list-item-title>
                </v-list-item-content>
              </v-list-item>
              
            </v-list-item-group>
          </v-list>
        </v-menu>
        <v-btn
          v-else
          small
          icon
          @click="agregarMaterial(item)"
        >
          <v-icon>mdi-cart-plus</v-icon>
        </v-btn>
      </template>
      <template v-slot:header.descripcion="{ header }">
        <div>
          {{ header.text }}
        </div>
        <div class="px-2">
          <input
            v-model="buscarDescripcion"
            type="text"
            class="input__search"
            @keyup.enter="resetCurrentPage"
          >
        </div>
      </template>
      <template v-slot:item.cantidad_inicial="{ }">
      </template>
      <template v-slot:item.precio_inicial="{ }">
      </template>
    </v-data-table>

    <FramePdf
      :fileUrl="filePdf"
      :dialog="dialog"
      @onCloseDialog="closeDialog"
    />
  </div>
</template>

<script>
import MaterialServicio from '@/store/services/MaterialServicio'
import FramePdf from '@/components/app/framePdf'
export default {
  name: "Materiales",
  components: {
    FramePdf
  },
  props: {
    esPedido: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return {
      listPerPage: [5, 10, 100, this.$t('todo')],
      perPage: 100,
      lastPage: 0,
      total: 0,
      currentPage: 1,
      materialData: [],
      selected: [],
      loading: false,
      filePdf: null,
      dialog: false,
      buscarDescripcion: ''
    }
  },
  methods: {
    verifyType(value) {
      return typeof value;
    },
    async getMateriales() {
      this.loading = true;
      const params = {
        page: this.currentPage,
        order_by: 'created_at',
        order_direction: 'DESC',
        per_page:
          this.verifyType(this.perPage) === 'string'
            ? this.total
            : this.perPage,
        search: this.search
      }
      try {
        let response = await MaterialServicio.index(params)
        this.materialData = response.data.data;
        this.currentPage = response.data.current_page;
        this.lastPage = response.data.last_page;
        this.total = response.data.total;
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          this.$notify({
            group: 'loggedIn',
            type: 'error',
            text: this.$t('errorAlCargar'),
          });
        }
      }
    },
    refreshTable() {
      this.refreshSearch();
      this.resetCurrentPage();
    },
    resetCurrentPage() {
      if (this.currentPage === 1) this.getMateriales();
      else this.currentPage = 1;
    },
    nuevoMaterial() {
      this.$emit('onNuevoMaterial');
    },
    editarMaterial(value) {
      console.log(value)
      this.$emit('onEditarMaterial', value)
    },
    agregarMaterial(value) {
      this.$emit('onAgregarMaterial', value)
    },
    async kardex(value) {
      try {
        let response = await MaterialServicio.kardex(value.id, {
          responseType: 'blob',
          Accept: 'application/pdf',
        })
        const url = window.URL.createObjectURL(new Blob([response.data], {type: 'application/pdf'}));
        this.filePdf = url
        this.dialog = true
      } catch (error) {
        console.log(error)
      }
    },
    closeDialog() {
      this.dialog = false
      this.filePdf = null
    },
    refreshSearch() {
      this.buscarDescripcion = ''
    },
    resetSearch(value)
    {
      switch (value) {
        case 'description':
          this.buscarDescripcion = ''
          break;
      }
      this.resetCurrentPage();
    },
    async eliminar(value) {
      try {
        this.loading = true
        await MaterialServicio.remove(value.id)
        this.refreshTable()
        this.loading = false
      } catch (error) {
        this.loading = false
        console.log(error)
      }
    },
    generateSearch(inputs) {
        let search = '';
        inputs.forEach(input => {
          if (input.value !== '')
            if (input.like) search += `${input.field}:%${input.value}% like;`;
            else search += `${input.field}:${input.value};`;
        });
        if (search.length > 0) {
          search = search.slice(0, -1);
        }
        return search;
    },
  },
  computed: {
    headers() {
      return [
        {
          value: 'actions',
          sortable: false,
        },
        /*{
          text: this.$t('id'),
          value: 'id',
          sortable: false,
        },*/
        {
          text: this.$t('codigo'),
          value: 'codigo',
          sortable: false,
        },
        {
          text: this.$t('descripcion'),
          value: 'descripcion',
          sortable: false,
        },
        {
          text: this.$t('saldo'),
          value: 'saldo',
          sortable: false,
        },
        {
          text: this.$t('marca'),
          value: 'marca',
          sortable: false,
        },
        {
          text: this.$t('color'),
          value: 'color',
          sortable: false,
        },
        {
          text: this.$t('tamanio'),
          value: 'tamanio',
          sortable: false,
        },
        {
          text: this.$t('unidManejo'),
          value: 'unid_manejo',
          sortable: false,
        },
        {
          text: this.$t('fechaRegistro'),
          value: 'fecha_registro',
          sortable: false,
        },
        {
          value: 'cantidad_inicial',
          sortable: false,
          visible: false,
        },
        {
          value: 'precio_inicial',
          sortable: false,
          visible: false,
        },
      ];
    },
    search() {
      let inputs = [
        { field: 'descripcion', value: this.buscarDescripcion, like: true },
      ];
      return this.generateSearch(inputs);
    },
  },
  watch: {
    currentPage() {
      this.getMateriales();
    },
  },
  created() {
    this.getMateriales()
  }
}
</script>

<style scoped>
  .input__search {
    border-radius: 0.3em;
    border: 1px solid #747474;
    width: 100%;
    padding-left: 0.3em;
    padding-top: 0%;
    padding-bottom: 0%;
    font-size: 14px;
    margin-top: 0%;
    margin-bottom: 0%;
  }
  .input__search:focus {
    outline: none;
    border: 1px solid #75aae2;
    box-shadow: 0 0 2px #719ece;
  }
  .v-text-field__slot input {
    padding: 0;
  }
</style>
